module Display (display,initializeGL) where

import Graphics.Rendering.OpenGL.Raw.ARB.Compatibility
import Graphics.Rendering.OpenGL.Raw.Core31
import Graphics.Rendering.OpenGL
import Graphics.UI.GLUT

import Pyramid
import Cube

display angle = do
  a <- get angle
  
  clear [ ColorBuffer ]
  clear [ DepthBuffer ]

  loadIdentity
  translate $ Vector3 (-1.5) 0.0 (-6.0::GLfloat)
  rotate a $ Vector3 0.0 1.0 (0.0::GLfloat)  
  pyramid (1.0::GLfloat)

  loadIdentity
  translate $ Vector3 (-1.5) 0.0 (-6.0::GLfloat)
  translate $ Vector3 3.0 0.0 (0.0::GLfloat)
  rotate a $ Vector3 0.0 1.0 (1.0::GLfloat)
  cube (1.0::GLfloat)
  
  flush
  
  angle $= a + 10.0
  
initializeGL = do
  shadeModel $= Smooth
  clearDepth $= (1.0::GLclampd)
  glEnable gl_DEPTH_TEST
  depthFunc $= Just Lequal
  glHint gl_PERSPECTIVE_CORRECTION_HINT gl_NICEST