module Cube where

import Graphics.Rendering.OpenGL
import Graphics.UI.GLUT

type GLpoint = (GLfloat, GLfloat, GLfloat)

cube w = do
  renderPrimitive Quads $ do
           -- Front side
           color $ Color3 1.0 0.0 (0.0::GLfloat)

           normal $ Normal3 0.0 0.0 (1.0::GLfloat)
           vertex $ Vertex3 (-w) (-w) w
           vertex $ Vertex3 w (-w) w
           vertex $ Vertex3 w w w
           vertex $ Vertex3 (-w) w w

           -- Back side
           color $ Color3 1.0 0.5 (0.0::GLfloat)

           normal $ Normal3 0 0 ((-1)::GLfloat)
           vertex $ Vertex3 (-w) (-w) (-w)
           vertex $ Vertex3 (-w) w (-w)
           vertex $ Vertex3 w w (-w)
           vertex $ Vertex3 w (-w) (-w)

           -- Top side
           color $ Color3 0.5 1.0 (0.0::GLfloat)

           normal $ Normal3 0 1 (0::GLfloat)
           vertex $ Vertex3 (-w) w (-w)
           vertex $ Vertex3 (-w) w w
           vertex $ Vertex3 w w w
           vertex $ Vertex3 w w (-w)

           -- Bottom side 
           color $ Color3 0.0 1.0 (0.0::GLfloat)

           normal $ Normal3 0 (-1) (0::GLfloat)
           vertex $ Vertex3 (-w) (-w) (-w)
           vertex $ Vertex3 w (-w) (-w)
           vertex $ Vertex3 w (-w) w
           vertex $ Vertex3 (-w) (-w) w

           -- Right side 
           color $ Color3 0.0 1.0 (0.5::GLfloat)

           normal $ Normal3 1 0 (0::GLfloat)
           vertex $ Vertex3 w w w
           vertex $ Vertex3 w w (-w)
           vertex $ Vertex3 w (-w) (-w)
           vertex $ Vertex3 w (-w) w
           
           -- Left side 
           color $ Color3 0.0 1.0 (1.0::GLfloat)

           normal $ Normal3 (-1) 0 (0::GLfloat)
           vertex $ Vertex3 (-w) (-w) (-w)
           vertex $ Vertex3 (-w) (-w) w
           vertex $ Vertex3 (-w) w w
           vertex $ Vertex3 (-w) w (-w)                     

  {-color $ Color3 1 1 (1::GLfloat)
  renderPrimitive Lines $ do
           vertex $ Vertex3 w w w
           vertex $ Vertex3 w w (-w)

           vertex $ Vertex3 w w (-w)
           vertex $ Vertex3 w (-w) (-w)
                  
           vertex $ Vertex3 w (-w) (-w)
           vertex $ Vertex3 w (-w) w

           vertex $ Vertex3 w (-w) w
           vertex $ Vertex3 w w w

           vertex $ Vertex3 (-w) w w
           vertex $ Vertex3 (-w) w (-w)

           vertex $ Vertex3 (-w) w (-w)
           vertex $ Vertex3 (-w) (-w) (-w)
                  
           vertex $ Vertex3 (-w) (-w) (-w)
           vertex $ Vertex3 (-w) (-w) w

           vertex $ Vertex3 (-w) (-w) w
           vertex $ Vertex3 (-w) w w

           vertex $ Vertex3 w w w
           vertex $ Vertex3 (-w) w w

           vertex $ Vertex3 w w (-w)
           vertex $ Vertex3 (-w) w (-w)

           vertex $ Vertex3 w (-w) (-w)
           vertex $ Vertex3 (-w) (-w) (-w)

           vertex $ Vertex3 w (-w) w
           vertex $ Vertex3 (-w) (-w) w-}